'use strict';

var GInternetProtSettingsBars = null;
var GCurrentInternetProtocolSetRegistryList = null;

function StoragePathFromControlsToJSONObject(ProtocolName)
{

  if (GetBaseProtocolName(ProtocolName) == 'FTP')
  {
    return GetJSONObject('parsestoragepath',
      [$('#inptIntProtSetFTP_url').jqxInput('val'),
        $('#inptInternetFolder').jqxInput('val'),
        $('#inptIntProtSet_FTP_login').jqxInput('val'),
        $('#inptPassword').jqxPasswordInput('val')
      ]);
  }
  else if (GetBaseProtocolName(ProtocolName) == 'SSH')
  {
    return GetJSONObject('parsestoragepath',
      [$('#inptIntProtSetSSH_url').jqxInput('val'),
        $('#inptInternetFolder').jqxInput('val'),
        $('#inptIntProtSet_SSH_login').jqxInput('val'),
        $('#inptPassword').jqxPasswordInput('val')
      ]);
  }
  else if (GetBaseProtocolName(ProtocolName) == 'WebDAV')
  {
    return GetJSONObject('parsestoragepath',
      [$('#inptIntProtSetWebDAV_url').jqxInput('val'),
        $('#inptInternetFolder').jqxInput('val'),
        $('#inptIntProtSet_WebDAV_login').jqxInput('val'),
        $('#inptPassword').jqxPasswordInput('val')
      ]);
  }
  else if (GetBaseProtocolName(ProtocolName) == 'Amazon S3')
  {
    return GetJSONObject('parsestoragepath',
      ['S3://' + $('#inptIntProtSet_AmazonS3_bucket').jqxInput('val'),
        $('#inptInternetFolder').jqxInput('val'),
        $('#inptIntProtSet_AmazonS3_access_id').jqxInput('val'),
        $('#inptPassword').jqxPasswordInput('val')
      ]);
  }
  else if ((GetBaseProtocolName(ProtocolName) == 'Google Drive') || (GetBaseProtocolName(ProtocolName) == 'GDriveAlike') || (ProtocolName == 'GDriveAlike'))
  {
    return GetJSONObject('parsestoragepath',
      ['ext://' + ProtocolName + '/',
        $('#inptInternetFolder').jqxInput('val'),
        $('#inptAccountID').jqxInput('val')
      ]);
  }
  else if (GetBaseProtocolName(ProtocolName) == 'Azure')
  {
    if (ProtocolName == 'Azure')
      return GetJSONObject('parsestoragepath',
        ['AZ://' + $('#inptIntProtSet_Azure_container').jqxInput('val'),
          $('#inptInternetFolder').jqxInput('val'),
          $('#inptIntProtSet_Azure_account_id').jqxInput('val'),
          $('#inptPassword').jqxPasswordInput('val')
        ]);
    else
      return GetJSONObject('parsestoragepath',
        ['ext://' + $('#inptIntProtSet_Azure_container').jqxInput('val'),
          $('#inptInternetFolder').jqxInput('val'),
          $('#inptIntProtSet_Azure_account_id').jqxInput('val'),
          $('#inptPassword').jqxPasswordInput('val')
        ]);
  }
  else if (GetBaseProtocolName(ProtocolName) == 'Sharepoint')
  {
    return GetJSONObject('parsestoragepath',
      ['ext://' + $('#inptIntProtSet_Sharepoint_domain').jqxInput('val'),
        $('#inptInternetFolder').jqxInput('val'),
        $('#inptIntProtSet_Sharepoint_account_id').jqxInput('val')
      ]);
  }
  else if (GetBaseProtocolName(ProtocolName) == 'RSync')
  {
    return GetJSONObject('parsestoragepath',
      [$('#inptIntProtSet_Rsync_url').jqxInput('val'),
        $('#inptInternetFolder').jqxInput('val'),
        $('#inptIntProtSet_Rsync_login').jqxInput('val'),
        $('#inptPassword').jqxPasswordInput('val')
      ]);
  }
  else if (GetBaseProtocolName(ProtocolName) == 'Glacier')
  {
    return GetJSONObject('parsestoragepath',
      ['GL://' + $('#inptIntProtSet_Glacier_Vault').jqxInput('val'),
        $('#inptInternetFolder').jqxInput('val'),
        $('#inpt_Glasier_account_id').jqxInput('val'),
        $('#inptPassword').jqxPasswordInput('val')
      ]);
  }
  else if (GetBaseProtocolName(ProtocolName) == 'HTTP')
  {
    return GetJSONObject('parsestoragepath',
      [$('#inptIntProtSet_HTTP_url').jqxInput('val'),
        $('#inptInternetFolder').jqxInput('val'),
        $('#inptIntProtSet_HTTP_login').jqxInput('val'),
        $('#inptPassword').jqxPasswordInput('val')
      ]);
  }

}

function m_OnProtocolComboItem(ProfileName, InternetProtocolSetRegistryList, ProtocolName, RawPathURL)
{
  try
  {

    //if( GProtocolName != ProtocolName )
    //   LoadDefaultsToRegistryList( InternetProtocolSetRegistryList, false );

    // GProtocolName = ProtocolName;

    if (GInternetProtSettingsBars != null)
    {
      GInternetProtSettingsBars.jqxNavigationBar('destroy');
      GInternetProtSettingsBars = null;
    }

    if (GetBaseProtocolName(ProtocolName) == 'FTP')
    {

      $("#internet_settings_navigationbar_div").html(InternetProtSettingsTabsHTML_FTP);

      function OnInitNavBarContent(p_index)
      {

        if (p_index == 0)
        {
          $('#InternetSettingsOK_btn').jqxButton('disabled', false);

          LoadRegistryItemToControlByName2('inptIntProtSetFTP_url', InternetProtocolSetRegistryList, 'FTP', 200);
          LoadRegistryItemToControlByName2('inptInternetFolder', InternetProtocolSetRegistryList, 'FTP', 200);
          LoadRegistryItemToControlByName2('inptIntProtSet_FTP_login', InternetProtocolSetRegistryList, 'FTP', 200);
          LoadRegistryItemToControlByName2('inptPassword', InternetProtocolSetRegistryList, 'FTP', 200);

          //overriding from RawURL
          var Obj = GetJSONObject('parseftpurl', [RawPathURL, GIntProtAbsolutePath]);
          if (Obj != undefined)
          {
            $('#inptIntProtSetFTP_url').jqxInput('val', 'ftp://' + Obj.server); //Obj.prefix
            $('#inptInternetFolder').jqxInput('val', Obj.folder);
            $('#inptIntProtSet_FTP_login').jqxInput('val', Obj.user);
            $('#inptPassword').jqxPasswordInput('val', Obj.password);
          }

          //initialization of some controls

          // LoadRegistryItemToControlByName2('jqxLibraryCombo', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_FTP_passive_mode', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('inptIntProtSet_FTP_port', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_allow_ipv6', InternetProtocolSetRegistryList, 'FTP');
        }
        else if (p_index == 1)
        {

          LoadRegistryItemToControlByName2('comboIntProtSet_FTP_adv_Charset', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_adv_replace_characters', InternetProtocolSetRegistryList, '*');
          LoadRegistryItemToControlByName2('cbIntProtSet_FTP_adv_ascii_transfer_mode', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_FTP_adv_server_supports_moving', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('comboIntProtSet_FTP_adv_ListingCommand', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_FTP_adv_verify_file', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_FTP_adv_respect_passive_mode', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('comboIntProtSet_FTP_adv_TimestampsForUploads', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_FTP_zoneauto', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_FTP_UTC', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('inptIntProtSet_FTP_adv_list', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('inptIntProtSet_FTP_adv_upload_min', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_timeout', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_retries', InternetProtocolSetRegistryList, 'FTP');
        }
        else if (p_index == 2)
        {
          LoadRegistryItemToControlByName2('comboIntProtSet_proxy_type', InternetProtocolSetRegistryList, 'FTP', 200);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_host', InternetProtocolSetRegistryList, 'FTP', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_port', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_login', InternetProtocolSetRegistryList, 'FTP', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_password', InternetProtocolSetRegistryList, 'FTP', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_FTP_proxy_send_host_command', InternetProtocolSetRegistryList, 'FTP');

        }
        else if (p_index == 3)
        {

          $("#rbIntProtSet_FTP_Security_security_none").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Security_Mode_Group'
          });
          $("#rbIntProtSet_FTP_Security_security_implisit_tsl").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Security_Mode_Group'
          });
          $("#rbIntProtSet_FTP_Security_security_explisit_tsl").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Security_Mode_Group'
          });

          LoadRegistryItemToControlByName2('IntProtSet_FTP_Security_Mode_Group', InternetProtocolSetRegistryList, 'FTP');

          $("#rbIntProtSet_FTP_Security_auto").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Auth_Cmd_Group'
          });
          $("#rbIntProtSet_FTP_Security_TLS").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Auth_Cmd_Group'
          });
          $("#rbIntProtSet_FTP_Security_SSL").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Auth_Cmd_Group'
          });
          $("#rbIntProtSet_FTP_Security_TLSC").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Auth_Cmd_Group'
          });
          $("#rbIntProtSet_FTP_Security_TLSP").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Auth_Cmd_Group'
          });

          LoadRegistryItemToControlByName2('IntProtSet_FTP_Auth_Cmd_Group', InternetProtocolSetRegistryList, 'FTP');

          $("#rbIntProtSet_FTP_Security_SSLv2").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Version_Group'
          });
          $("#rbIntProtSet_FTP_Security_SSLv2_3").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Version_Group'
          });
          $("#rbIntProtSet_FTP_Security_SSLv3").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Version_Group'
          });
          $("#rbIntProtSet_FTP_Security_TLSv_1_1_2").jqxRadioButton(
          {
            groupName: 'IntProtSet_FTP_Version_Group'
          });

          LoadRegistryItemToControlByName2('IntProtSet_FTP_Version_Group', InternetProtocolSetRegistryList, 'FTP');

          LoadRegistryItemToControlByName2('comboIntProtSet_FTP_security_Certificate', InternetProtocolSetRegistryList, 'FTP', 100);
          LoadRegistryItemToControlByName2('inptIntProtSet_FTP_security_CertificatePassword', InternetProtocolSetRegistryList, 'FTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_FTP_security_nopassword', InternetProtocolSetRegistryList, 'FTP', 100);
        }
      }

      function InitFtpBar()
      {
        if (InternetProtSettingsTabsHTML_FTP == '') return;
        $("#internet_settings_navigationbar_div").html(InternetProtSettingsTabsHTML_FTP);
        $("#jqx_internet_settings_navigationbar").jqxNavigationBar(
        {
          width: '100%',
          height: 600,
          toggleMode: "dblclick",
          expandMode: "toggle",
          initContent: OnInitNavBarContent
        });

        $("div.first").replaceWith('<div class="inner first"><br/>' + ProtocolName + ' Settings<br/></div>');

        GInternetProtSettingsBars = $("#jqx_internet_settings_navigationbar");
      }
      if (InternetProtSettingsTabsHTML_FTP == '')
      {
        var client = new XMLHttpRequest();
        client.open('GET', '/m_InternetSettingsNavigationBar_FTP.html');
        client.onreadystatechange = function()
        {
          if (client.readyState == XMLHttpRequest.DONE)
          {
             InternetProtSettingsTabsHTML_FTP = client.responseText;
             InitFtpBar();
          }
        }
        client.send();
      }
      else
        InitFtpBar();

    }
    else if (GetBaseProtocolName(ProtocolName) == 'SSH')
    {

      function OnInitNavBarContent(p_index)
      {

        if (p_index == 0)
        {

          $('#InternetSettingsOK_btn').jqxButton('disabled', false);

          LoadRegistryItemToControlByName2('jqxLibraryCombo', InternetProtocolSetRegistryList, 'SSH');

          //initialization of some controls
          LoadRegistryItemToControlByName2('inptIntProtSetSSH_url', InternetProtocolSetRegistryList, 'SSH', 200);
          LoadRegistryItemToControlByName2('inptInternetFolder', InternetProtocolSetRegistryList, 'SSH', 200);
          LoadRegistryItemToControlByName2('inptIntProtSet_SSH_login', InternetProtocolSetRegistryList, 'SSH', 200);
          LoadRegistryItemToControlByName2('inptPassword', InternetProtocolSetRegistryList, 'SSH', 200);

          //overriding from RawURL
          var Obj = GetJSONObject('parseftpurl', [RawPathURL, GIntProtAbsolutePath]);
          if (Obj != undefined)
          {
            $('#inptIntProtSetSSH_url').jqxInput('val', 'sftp://' + Obj.server);
            $('#inptInternetFolder').jqxInput('val', Obj.folder);
            $('#inptIntProtSet_SSH_login').jqxInput('val', Obj.user);
            $('#inptPassword').jqxPasswordInput('val', Obj.password);
          }

          LoadRegistryItemToControlByName2('inptIntProtSet_SSH_port', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('cbIntProtSet_allow_ipv6', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('cbIntProtSet_SSH_usePutty', InternetProtocolSetRegistryList, 'SSH');
        }
        else if (p_index == 1)
        {

          LoadRegistryItemToControlByName2('comboIntProtSet_SSH_adv_Charset', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('cbIntProtSet_adv_replace_characters', InternetProtocolSetRegistryList, '*');
          LoadRegistryItemToControlByName2('cbIntProtSet_recursive_listing', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('cbIntProtSet_SSH_adv_verify_destination_file', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('cbIntProtSet_SSH_zoneauto', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('cbIntProtSet_SSH_UTC', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('inptIntProtSet_SSH_adv_list', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('inptIntProtSet_SSH_adv_upload_min', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_timeout', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_retries', InternetProtocolSetRegistryList, 'SSH');

        }
        else if (p_index == 2)
        {

          LoadRegistryItemToControlByName2('comboIntProtSet_proxy_type', InternetProtocolSetRegistryList, 'SSH', 200);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_host', InternetProtocolSetRegistryList, 'SSH', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_port', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_user_id', InternetProtocolSetRegistryList, 'SSH', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_password', InternetProtocolSetRegistryList, 'SSH', 195);

        }
        else if (p_index == 3)
        {
          $('#btnIntProtSet_SSH_Security_Advanced_SSH').jqxButton(
          {
            width: 200,
            height: 40
          });
          LoadRegistryItemToControlByName2('cbIntProtSet_SSH_Security_username_password', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('cbIntProtSet_SSH_Security_keyboard', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('cbIntProtSet_SSH_Security_certificate', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('comboIntProtSet_SSH_security_Certificate', InternetProtocolSetRegistryList, 'SSH');
          LoadRegistryItemToControlByName2('inptIntProtSet_SSH_security_CertificatePassword', InternetProtocolSetRegistryList, 'SSH', 200);
          LoadRegistryItemToControlByName2('cbIntProtSet_SSH_security_nopassword', InternetProtocolSetRegistryList, 'SSH');
        }
      }

      function InitSftpBar()
      {
        if (InternetProtSettingsTabsHTML_SFTP == '') return;
        $("#internet_settings_navigationbar_div").html(InternetProtSettingsTabsHTML_SFTP);
        $("#jqx_internet_settings_navigationbar").jqxNavigationBar(
        {
          width: '100%',
          height: 600,
          toggleMode: "dblclick",
          expandMode: "toggle",
          initContent: OnInitNavBarContent
        });

        $("div.first").replaceWith('<div class="inner first"><br/>' + ProtocolName + ' Settings<br/></div>');

        GInternetProtSettingsBars = $("#jqx_internet_settings_navigationbar");
      }

      if (InternetProtSettingsTabsHTML_SFTP == '')
      {
        var client = new XMLHttpRequest();
        client.open('GET', '/m_InternetSettingsNavigationBar_SFTP.html');
        client.onreadystatechange = function()
        {
          if (client.readyState == XMLHttpRequest.DONE)
          {
             InternetProtSettingsTabsHTML_SFTP = client.responseText;
             InitSftpBar();
          }
        }
        client.send();
      }
      else
        InitSftpBar();

    }
    else if (GetBaseProtocolName(ProtocolName) == 'WebDAV')
    {
      function OnInitNavBarContent(p_index)
      {

        if (p_index == 0)
        {

          $('#InternetSettingsOK_btn').jqxButton('disabled', false);

          LoadRegistryItemToControlByName2('jqxLibraryCombo', InternetProtocolSetRegistryList, 'WebDAV', 200);
          LoadRegistryItemToControlByName2('inptIntProtSetWebDAV_url', InternetProtocolSetRegistryList, 'WebDAV', 195);
          LoadRegistryItemToControlByName2('jqxWebDAVAuthenticationCombo', InternetProtocolSetRegistryList, 'WebDAV', 200);
          LoadRegistryItemToControlByName2('inptInternetFolder', InternetProtocolSetRegistryList, 'WebDAV', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_WebDAV_login', InternetProtocolSetRegistryList, 'WebDAV', 195);
          LoadRegistryItemToControlByName2('inptPassword', InternetProtocolSetRegistryList, 'WebDAV', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_allow_ipv6', InternetProtocolSetRegistryList, 'WebDAV');

          var Obj = GetJSONObject('parseftpurl', [RawPathURL]);
          if (Obj != undefined)
          {
            $('#inptIntProtSetWebDAV_url').jqxInput('val', Obj.prefix + Obj.server);
            $('#inptInternetFolder').jqxInput('val', Obj.folder);
            $('#inptIntProtSet_WebDAV_login').jqxInput('val', Obj.user);
            $('#inptPassword').jqxPasswordInput('val', Obj.password);
          }
        }
        else if (p_index == 1)
        {
          LoadRegistryItemToControlByName2('comboIntProtSet_WebDAV_adv_Charset', InternetProtocolSetRegistryList, 'WebDAV');
          LoadRegistryItemToControlByName2('cbIntProtSet_adv_replace_characters', InternetProtocolSetRegistryList, '*');
          LoadRegistryItemToControlByName2('comboIntProtSet_WebDAV_adv_strategyCombo', InternetProtocolSetRegistryList, 'WebDAV', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_WebDAV_adv_use_displayname', InternetProtocolSetRegistryList, 'WebDAV');
          LoadRegistryItemToControlByName2('comboIntProtSet_WebDAV_adv_use_expect_100_continue', InternetProtocolSetRegistryList, 'WebDAV');
          LoadRegistryItemToControlByName2('comboIntProtSet_WebDAV_adv_TimestampsForUploads', InternetProtocolSetRegistryList, 'WebDAV');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_timeout', InternetProtocolSetRegistryList, 'WebDAV');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_retries', InternetProtocolSetRegistryList, 'WebDAV');
          LoadRegistryItemToControlByName2('inptIntProtSet_WebDAV_adv_http_retries', InternetProtocolSetRegistryList, 'WebDAV');

        }
        else if (p_index == 2)
        {
          LoadRegistryItemToControlByName2('comboIntProtSet_proxy_type', InternetProtocolSetRegistryList, 'WebDAV', 200);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_host', InternetProtocolSetRegistryList, 'WebDAV', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_port', InternetProtocolSetRegistryList, 'WebDAV');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_login', InternetProtocolSetRegistryList, 'WebDAV', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_password', InternetProtocolSetRegistryList, 'WebDAV', 195);

        }
        else if (p_index == 3)
        {

          $("#rbIntProtSet_WebDAV_Security_SSLv2").jqxRadioButton(
          {
            groupName: "IntProtSet_WebDAV_Version_Group"
          });
          $("#rbIntProtSet_WebDAV_Security_SSLv2_3").jqxRadioButton(
          {
            groupName: "IntProtSet_WebDAV_Version_Group"
          });
          $("#rbIntProtSet_WebDAV_Security_SSLv3").jqxRadioButton(
          {
            groupName: "IntProtSet_WebDAV_Version_Group"
          });
          $("#rbIntProtSet_WebDAV_Security_TLSv_1_1_2").jqxRadioButton(
          {
            groupName: "IntProtSet_WebDAV_Version_Group"
          });
          LoadRegistryItemToControlByName2('IntProtSet_WebDAV_Version_GroupWidget', InternetProtocolSetRegistryList, 'WebDAV');
        }

      };

      function InitWebDavBar()
      {
        if (InternetProtSettingsTabsHTML_WebDAV == '') return;
        $("#internet_settings_navigationbar_div").html(InternetProtSettingsTabsHTML_WebDAV);
        $("#jqx_internet_settings_navigationbar").jqxNavigationBar(
        {
          width: '100%',
          height: 600,
          toggleMode: "dblclick",
          expandMode: "toggle",
          initContent: OnInitNavBarContent
        });

        $("div.first").replaceWith('<div class="inner first"><br/>' + ProtocolName + ' Settings<br/></div>');

        GInternetProtSettingsBars = $("#jqx_internet_settings_navigationbar");
      }

      if (InternetProtSettingsTabsHTML_WebDAV == '')
      {
        var client = new XMLHttpRequest();
        client.open('GET', '/m_InternetSettingsNavigationBar_WebDav.html');
        client.onreadystatechange = function()
        {
          if (client.readyState == XMLHttpRequest.DONE)
          {
             InternetProtSettingsTabsHTML_WebDAV = client.responseText;
             InitWebDavBar();
          }
        }
        client.send();
      }
      else
        InitWebDavBar();

    }
    else if (GetBaseProtocolName(ProtocolName) == 'Amazon S3')
    {

      function OnInitNavBarContent(p_index)
      {
        if (p_index == 0)
        {
          $('#InternetSettingsOK_btn').jqxButton('disabled', false);

          LoadRegistryItemToControlByName2('inptIntProtSet_AmazonS3_bucket', InternetProtocolSetRegistryList, 'Amazon S3', 195);
          LoadRegistryItemToControlByName2('comboS3StorageClass', InternetProtocolSetRegistryList, 'Amazon S3', 200);
          LoadRegistryItemToControlByName2('inptInternetFolder', InternetProtocolSetRegistryList, 'Amazon S3', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_AmazonS3_access_id', InternetProtocolSetRegistryList, 'Amazon S3', 195);
          LoadRegistryItemToControlByName2('inptPassword', InternetProtocolSetRegistryList, 'Amazon S3', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_allow_ipv6', InternetProtocolSetRegistryList, 'Amazon S3');

          var Obj = GetJSONObject('parseftpurl', [RawPathURL]);
          if (Obj != undefined)
          {
            $('#inptIntProtSet_AmazonS3_bucket').jqxInput('val', Obj.server);
            $('#inptInternetFolder').jqxInput('val', Obj.folder);
            $('#inptIntProtSet_AmazonS3_access_id').jqxInput('val', Obj.user);
            $('#inptPassword').jqxPasswordInput('val', Obj.password);
          }

        }
        else if (p_index == 1)
        {
          LoadRegistryItemToControlByName2('cbIntProtSet_adv_replace_characters', InternetProtocolSetRegistryList, '*');
          LoadRegistryItemToControlByName2('cbIntProtSet_AmazonS3_make_uploaded_files_pub_available', InternetProtocolSetRegistryList, 'Amazon S3');
          LoadRegistryItemToControlByName2('cbIntProtSet_recursive_listing', InternetProtocolSetRegistryList, 'Amazon S3');
          LoadRegistryItemToControlByName2('cbIntProtSet_AmazonS3_use_server_side_encryption', InternetProtocolSetRegistryList, 'Amazon S3');
          LoadRegistryItemToControlByName2('cbIntProtSet_AmazonS3_use_transfer_acceleration', InternetProtocolSetRegistryList, 'Amazon S3');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_retries', InternetProtocolSetRegistryList, 'Amazon S3', 195);
        }
        else if (p_index == 2)
        {
          LoadRegistryItemToControlByName2('comboIntProtSet_proxy_type', InternetProtocolSetRegistryList, 'Amazon S3', 200);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_host', InternetProtocolSetRegistryList, 'Amazon S3', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_port', InternetProtocolSetRegistryList, 'Amazon S3');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_login', InternetProtocolSetRegistryList, 'Amazon S3', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_password', InternetProtocolSetRegistryList, 'Amazon S3', 195);

        }
      };

      function InitAmazonS3Bar()
      {
        if (InternetProtSettingsTabsHTML_AmazonS3 == '') return;
        $("#internet_settings_navigationbar_div").html(InternetProtSettingsTabsHTML_AmazonS3);
        $("#jqx_internet_settings_navigationbar").jqxNavigationBar(
        {
          width: '100%',
          height: 600,
          toggleMode: "dblclick",
          expandMode: "toggle",
          initContent: OnInitNavBarContent
        });

        $("div.first").replaceWith('<div class="inner first"><br/>' + ProtocolName + ' Settings<br/></div>');

        GInternetProtSettingsBars = $("#jqx_internet_settings_navigationbar");
      }

      if (InternetProtSettingsTabsHTML_AmazonS3 == '')
      {
        var client = new XMLHttpRequest();
        client.open('GET', '/m_InternetSettingsNavigationBar_AmazonS3.html');
        client.onreadystatechange = function()
        {
          if (client.readyState == XMLHttpRequest.DONE)
          {
             InternetProtSettingsTabsHTML_AmazonS3 = client.responseText;
             InitAmazonS3Bar();
          }
        }
        client.send();
      }
      else
        InitAmazonS3Bar();

    }
    else if (GetBaseProtocolName(ProtocolName) == 'Google Drive')
    {

      function OnInitNavBarContent(p_index)
      {

        if (p_index == 0)
        {
          $('#InternetSettingsOK_btn').jqxButton('disabled', false);

          LoadRegistryItemToControlByName2('inptInternetFolder', InternetProtocolSetRegistryList, 'Google Drive', 195);
          LoadRegistryItemToControlByName2('inptAccountID', InternetProtocolSetRegistryList, 'Google Drive', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_allow_ipv6', InternetProtocolSetRegistryList, 'Google Drive');

          var Obj = GetJSONObject('parseftpurl', [RawPathURL]);
          if (Obj != undefined)
          {
            $('#inptInternetFolder').jqxInput('val', Obj.folder);
            $('#inptAccountID').jqxInput('val', Obj.user);
          }
        }
        else if (p_index == 1)
        {
          LoadRegistryItemToControlByName2('cbIntProtSet_adv_replace_characters', InternetProtocolSetRegistryList, '*');
          LoadRegistryItemToControlByName2('cbIntProtSet_GDrive_adv_enable_doc_convercion', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbIntProtSet_GDrive_create_links', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_timeout', InternetProtocolSetRegistryList, 'Google Drive', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_retries', InternetProtocolSetRegistryList, 'Google Drive', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_recursive_listing', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbIntProtSet_AvoidChangesAPIInitialListing', InternetProtocolSetRegistryList, 'Google Drive');
        }
        else if (p_index == 2)
        {
          LoadRegistryItemToControlByName2('comboIntProtSet_proxy_type', InternetProtocolSetRegistryList, 'Google Drive', 200);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_host', InternetProtocolSetRegistryList, 'Google Drive', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_port', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_login', InternetProtocolSetRegistryList, 'Google Drive', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_password', InternetProtocolSetRegistryList, 'Google Drive', 195);

        }
        else if (p_index == 3)
        {
          $("#rbGDocs_Spread_xlsx").jqxRadioButton(
          {
            groupName: 'GDocs_Spreads_Group'
          });
          $("#rbGDocs_Spread_csv").jqxRadioButton(
          {
            groupName: 'GDocs_Spreads_Group'
          });
          $("#rbGDocs_Spread_pdf").jqxRadioButton(
          {
            groupName: 'GDocs_Spreads_Group'
          });

          LoadRegistryItemToControlByName2('GDocs_Spreads_Group', InternetProtocolSetRegistryList, 'Google Drive');

          $("#rbGDocs_TextDocs_docx").jqxRadioButton(
          {
            groupName: 'GDocs_Docs_Group'
          });
          $("#rbGDocs_TextDocs_odt").jqxRadioButton(
          {
            groupName: 'GDocs_Docs_Group'
          });
          $("#rbGDocs_TextDocs_rtf").jqxRadioButton(
          {
            groupName: 'GDocs_Docs_Group'
          });
          $("#rbGDocs_TextDocs_html").jqxRadioButton(
          {
            groupName: 'GDocs_Docs_Group'
          });
          $("#rbGDocs_TextDocs_pdf").jqxRadioButton(
          {
            groupName: 'GDocs_Docs_Group'
          });
          $("#rbGDocs_TextDocs_txt").jqxRadioButton(
          {
            groupName: 'GDocs_Docs_Group'
          });

          LoadRegistryItemToControlByName2('GDocs_Docs_Group', InternetProtocolSetRegistryList, 'Google Drive');

          $("#rbGDocs_Pres_pptx").jqxRadioButton(
          {
            groupName: 'GDocs_Pres_Group'
          });
          $("#rbGDocs_Pres_txt").jqxRadioButton(
          {
            groupName: 'GDocs_Pres_Group'
          });
          $("#rbGDocs_Pres_pdf").jqxRadioButton(
          {
            groupName: 'GDocs_Pres_Group'
          });

          LoadRegistryItemToControlByName2('GDocs_Pres_Group', InternetProtocolSetRegistryList, 'Google Drive');

          $("#rbGDocs_Draw_jpg").jqxRadioButton(
          {
            groupName: 'GDocs_Draw_Group'
          });
          $("#rbGDocs_Draw_png").jqxRadioButton(
          {
            groupName: 'GDocs_Draw_Group'
          });
          $("#rbGDocs_Draw_pdf").jqxRadioButton(
          {
            groupName: 'GDocs_Draw_Group'
          });
          $("#rbGDocs_Draw_xml").jqxRadioButton(
          {
            groupName: 'GDocs_Draw_Group'
          });

          LoadRegistryItemToControlByName2('GDocs_Draw_Group', InternetProtocolSetRegistryList, 'Google Drive');

          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_csv', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_html', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_pdf', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_pptx', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_txt', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_doc', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_ods', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_pps', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_rtf', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_xls', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_docx', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_odt', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_ppt', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_tsv', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbGDocs_ftconvert_xlsx', InternetProtocolSetRegistryList, 'Google Drive');
          LoadRegistryItemToControlByName2('cbIntProtSet_GDrive_clenup_in_folder', InternetProtocolSetRegistryList, 'Google Drive');

        }

      };

      function InitGoogleDriveBar()
      {
        if (InternetProtSettingsTabsHTML_GoogleDrive == '') return;
        $("#internet_settings_navigationbar_div").html(InternetProtSettingsTabsHTML_GoogleDrive);
        $("#jqx_internet_settings_navigationbar").jqxNavigationBar(
        {
          width: '100%',
          height: 1000,
          toggleMode: "dblclick",
          expandMode: "toggle",
          initContent: OnInitNavBarContent
        });

        $("div.first").replaceWith('<div class="inner first"><br/>' + ProtocolName + ' Settings<br/></div>');

        GInternetProtSettingsBars = $("#jqx_internet_settings_navigationbar");
      }

      if (InternetProtSettingsTabsHTML_GoogleDrive == '')
      {
        var client = new XMLHttpRequest();
        client.open('GET', '/m_InternetSettingsNavigationBar_GoogleDrive.html');
        client.onreadystatechange = function()
        {
          if (client.readyState == XMLHttpRequest.DONE)
          {
             InternetProtSettingsTabsHTML_GoogleDrive = client.responseText;
             InitGoogleDriveBar();
          }
        }
        client.send();
      }
      else
        InitGoogleDriveBar();

    }
    else if (GetBaseProtocolName(ProtocolName) == 'Azure')
    {

      function OnInitNavBarContent(p_index)
      {

        if (p_index == 0)
        {

          $('#InternetSettingsOK_btn').jqxButton('disabled', false);

          LoadRegistryItemToControlByName2('inptIntProtSet_Azure_container', InternetProtocolSetRegistryList, 'Azure', 195);
          LoadRegistryItemToControlByName2('inptInternetFolder', InternetProtocolSetRegistryList, 'Azure', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_Azure_account_id', InternetProtocolSetRegistryList, 'Azure', 195);
          LoadRegistryItemToControlByName2('inptPassword', InternetProtocolSetRegistryList, 'Azure', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_allow_ipv6', InternetProtocolSetRegistryList, 'Azure');

          var Obj = GetJSONObject('parseftpurl', [RawPathURL]);
          if (Obj != undefined)
          {
            $('#inptIntProtSet_Azure_container').jqxInput('val', Obj.server);
            $('#inptInternetFolder').jqxInput('val', Obj.folder);
            $('#inptIntProtSet_Azure_account_id').jqxInput('val', Obj.user);
            $('#inptPassword').jqxPasswordInput('val', Obj.password);
          }
        }
        else if (p_index == 1)
        {
          LoadRegistryItemToControlByName2('cbIntProtSet_adv_replace_characters', InternetProtocolSetRegistryList, '*');
          LoadRegistryItemToControlByName2('cbIntProtSet_recursive_listing', InternetProtocolSetRegistryList, 'Azure');
          LoadRegistryItemToControlByName2('inptIntProtSet_Azure_adv_cache_control', InternetProtocolSetRegistryList, 'Azure');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_timeout', InternetProtocolSetRegistryList, 'Azure');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_retries', InternetProtocolSetRegistryList, 'Azure');
        }
        else if (p_index == 2)
        {
          LoadRegistryItemToControlByName2('comboIntProtSet_proxy_type', InternetProtocolSetRegistryList, 'Azure', 200);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_host', InternetProtocolSetRegistryList, 'Azure', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_port', InternetProtocolSetRegistryList, 'Azure');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_login', InternetProtocolSetRegistryList, 'Azure', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_password', InternetProtocolSetRegistryList, 'Azure', 195);

        }
      };

      function InitAzureBar()
      {
        if (InternetProtSettingsTabsHTML_Azure == '') return;
        $("#internet_settings_navigationbar_div").html(InternetProtSettingsTabsHTML_Azure);
        $("#jqx_internet_settings_navigationbar").jqxNavigationBar(
        {
          width: '100%',
          height: 1000,
          toggleMode: "dblclick",
          expandMode: "toggle",
          initContent: OnInitNavBarContent
        });

        $("div.first").replaceWith('<div class="inner first"><br/>' + ProtocolName + ' Settings<br/></div>');

        GInternetProtSettingsBars = $("#jqx_internet_settings_navigationbar");
      }
      if (InternetProtSettingsTabsHTML_Azure == '')
      {
        var client = new XMLHttpRequest();
        client.open('GET', '/m_InternetSettingsNavigationBar_Azure.html');
        client.onreadystatechange = function()
        {
          if (client.readyState == XMLHttpRequest.DONE)
          {
             InternetProtSettingsTabsHTML_Azure = client.responseText;
             InitAzureBar();
          }
        }
        client.send();
      }
      else
        InitAzureBar();

    }
    else if (GetBaseProtocolName(ProtocolName) == 'GDriveAlike')
    {

      function OnInitNavBarContent(p_index)
      {

        if (p_index == 0)
        {
          $('#InternetSettingsOK_btn').jqxButton('disabled', false);

          LoadRegistryItemToControlByName2('inptInternetFolder', InternetProtocolSetRegistryList, 'GDriveAlike', 195);
          LoadRegistryItemToControlByName2('inptAccountID', InternetProtocolSetRegistryList, 'GDriveAlike', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_allow_ipv6', InternetProtocolSetRegistryList, 'GDriveAlike', 195);
          var Obj = GetJSONObject('parseftpurl', [RawPathURL]);
          if (Obj != undefined)
          {
            $('#inptInternetFolder').jqxInput('val', Obj.folder);
            $('#inptAccountID').jqxInput('val', Obj.user);
          }
        }
        else if (p_index == 1)
        {
          LoadRegistryItemToControlByName2('cbIntProtSet_adv_replace_characters', InternetProtocolSetRegistryList, '*');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_timeout', InternetProtocolSetRegistryList, 'GDriveAlike');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_retries', InternetProtocolSetRegistryList, 'GDriveAlike');
          LoadRegistryItemToControlByName2('cbIntProtSet_recursive_listing', InternetProtocolSetRegistryList, 'GDriveAlike');
        }
        else if (p_index == 2)
        {
          LoadRegistryItemToControlByName2('comboIntProtSet_proxy_type', InternetProtocolSetRegistryList, 'GDriveAlike', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_host', InternetProtocolSetRegistryList, 'GDriveAlike', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_port', InternetProtocolSetRegistryList, 'GDriveAlike');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_login', InternetProtocolSetRegistryList, 'GDriveAlike', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_password', InternetProtocolSetRegistryList, 'GDriveAlike', 195);
        }
      }

      function InitGDriveAlikeBar()
      {
        if (InternetProtSettingsTabsHTML_GDriveRelevant == '') return;
        $("#internet_settings_navigationbar_div").html(InternetProtSettingsTabsHTML_GDriveRelevant);
        $("#jqx_internet_settings_navigationbar").jqxNavigationBar(
        {
          width: '100%',
          height: 1000,
          toggleMode: "dblclick",
          expandMode: "toggle",
          initContent: OnInitNavBarContent
        });

        $("div.first").replaceWith('<div class="inner first"><br/>' + ProtocolName + ' Settings<br/></div>');

        GInternetProtSettingsBars = $("#jqx_internet_settings_navigationbar");
      }
      if (InternetProtSettingsTabsHTML_GDriveRelevant == '')
      {
        var client = new XMLHttpRequest();
        client.open('GET', '/m_InternetSettingsNavigationBar_GDriveRelevant.html');
        client.onreadystatechange = function()
        {
          if (client.readyState == XMLHttpRequest.DONE)
          {
             InternetProtSettingsTabsHTML_GDriveRelevant = client.responseText;
             InitGDriveAlikeBar();
          }
        }
        client.send();
      }
      else
        InitGDriveAlikeBar();
    }
    else if (GetBaseProtocolName(ProtocolName) == 'Glacier')
    {

      function OnInitNavBarContent(p_index)
      {

        if (p_index == 0)
        {
          $('#InternetSettingsOK_btn').jqxButton('disabled', false);

          LoadRegistryItemToControlByName2('inptIntProtSet_Glacier_Vault', InternetProtocolSetRegistryList, 'Glacier', 195);
          LoadRegistryItemToControlByName2('comboIntProtSet_Glacier_Region', InternetProtocolSetRegistryList, 'Glacier', 200);
          LoadRegistryItemToControlByName2('inptInternetFolder', InternetProtocolSetRegistryList, 'Glacier', 195);
          LoadRegistryItemToControlByName2('inpt_Glasier_account_id', InternetProtocolSetRegistryList, 'Glacier', 195);
          LoadRegistryItemToControlByName2('inptPassword', InternetProtocolSetRegistryList, 'Glacier', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_allow_ipv6', InternetProtocolSetRegistryList, 'Glacier');
          var Obj = GetJSONObject('parseftpurl', [RawPathURL]);
          if (Obj != undefined)
          {
            $('#inptIntProtSet_Glacier_Vault').jqxInput('val', Obj.server);
            $('#inptInternetFolder').jqxInput('val', Obj.folder);
            $('#inpt_Glasier_account_id').jqxInput('val', Obj.user);
            $('#inptPassword').jqxPasswordInput('val', Obj.password);
          }
        }
        else if (p_index == 1)
        {
          LoadRegistryItemToControlByName2('cbIntProtSet_recursive_listing', InternetProtocolSetRegistryList, 'Glacier');
          LoadRegistryItemToControlByName2('cbIntProtSet_adv_replace_characters', InternetProtocolSetRegistryList, '*');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_timeout', InternetProtocolSetRegistryList, 'Glacier');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_retries', InternetProtocolSetRegistryList, 'Glacier');

        }
        else if (p_index == 2)
        {
          LoadRegistryItemToControlByName2('comboIntProtSet_proxy_type', InternetProtocolSetRegistryList, 'Glacier', 200);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_host', InternetProtocolSetRegistryList, 'Glacier', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_port', InternetProtocolSetRegistryList, 'Glacier');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_login', InternetProtocolSetRegistryList, 'Glacier', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_password', InternetProtocolSetRegistryList, 'Glacier', 195);
        }
      }

      function InitGlacierBar()
      {
        if (InternetProtSettingsTabsHTML_Glacier == '') return;
        $("#internet_settings_navigationbar_div").html(InternetProtSettingsTabsHTML_Glacier);
        $("#jqx_internet_settings_navigationbar").jqxNavigationBar(
        {
          width: '100%',
          height: 1000,
          toggleMode: "dblclick",
          expandMode: "toggle",
          initContent: OnInitNavBarContent
        });

        $("div.first").replaceWith('<div class="inner first"><br/>' + ProtocolName + ' Settings<br/></div>');

        GInternetProtSettingsBars = $("#jqx_internet_settings_navigationbar");
      }
      if (InternetProtSettingsTabsHTML_Glacier == '')
      {
        var client = new XMLHttpRequest();
        client.open('GET', '/m_InternetSettingsNavigationBar_Glacier.html');
        client.onreadystatechange = function()
        {
          if (client.readyState == XMLHttpRequest.DONE)
          {
             InternetProtSettingsTabsHTML_Glacier = client.responseText;
             InitGlacierBar();
          }
        }
        client.send();
      }
      else
        InitGlacierBar();

    }
    else if (GetBaseProtocolName(ProtocolName) == 'HTTP')
    {
      function OnInitNavBarContent(p_index)
      {

        if (p_index == 0)
        {
          $('#InternetSettingsOK_btn').jqxButton('disabled', false);

          LoadRegistryItemToControlByName2('inptIntProtSet_HTTP_url', InternetProtocolSetRegistryList, 'HTTP', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_HTTP_port', InternetProtocolSetRegistryList, 'HTTP');
          LoadRegistryItemToControlByName2('inptInternetFolder', InternetProtocolSetRegistryList, 'HTTP', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_HTTP_login', InternetProtocolSetRegistryList, 'HTTP', 195);
          LoadRegistryItemToControlByName2('inptPassword', InternetProtocolSetRegistryList, 'HTTP', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_allow_ipv6', InternetProtocolSetRegistryList, 'HTTP');

          var Obj = GetJSONObject('parseftpurl', [RawPathURL]);
          if (Obj != undefined)
          {
            $('#inptIntProtSet_HTTP_url').jqxInput('val', Obj.prefix + Obj.server);
            $('#inptInternetFolder').jqxInput('val', Obj.folder);
            $('#inptIntProtSet_HTTP_login').jqxInput('val', Obj.user);
            $('#inptPassword').jqxPasswordInput('val', Obj.password);
          }

        }
        else if (p_index == 1)
        {
          LoadRegistryItemToControlByName2('cbIntProtSet_HTTP_HTML_download_and_parse', InternetProtocolSetRegistryList, 'HTTP');
          LoadRegistryItemToControlByName2('inptIntProtSet_HTTP_HTML_parsing_limit', InternetProtocolSetRegistryList, 'HTTP', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_HTTP_HTML_enquire_timestamp', InternetProtocolSetRegistryList, 'HTTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_HTTP_HTML_enquire_precise_info', InternetProtocolSetRegistryList, 'HTTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_HTTP_HTML_download_default_pages', InternetProtocolSetRegistryList, 'HTTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_HTTP_HTML_consider_locally_existing_files', InternetProtocolSetRegistryList, 'HTTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_HTTP_HTML_assume_local_files', InternetProtocolSetRegistryList, 'HTTP');
          LoadRegistryItemToControlByName2('cbIntProtSet_HTTP_HTML_avoid_re_downloading', InternetProtocolSetRegistryList, 'HTTP');
          LoadRegistryItemToControlByName2('jqxLinksAboveCombo', InternetProtocolSetRegistryList, 'HTTP', 100);
          LoadRegistryItemToControlByName2('jqxLinksToOtherDomainsCombo', InternetProtocolSetRegistryList, 'HTTP', 100);
        }
        else if (p_index == 2)
        {
          LoadRegistryItemToControlByName2('cbIntProtSet_adv_replace_characters', InternetProtocolSetRegistryList, '*');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_timeout', InternetProtocolSetRegistryList, 'HTTP');
          LoadRegistryItemToControlByName2('inptIntProtSet_adv_retries', InternetProtocolSetRegistryList, 'HTTP');
        }
        else if (p_index == 3)
        {
          LoadRegistryItemToControlByName2('comboIntProtSet_proxy_type', InternetProtocolSetRegistryList, 'HTTP', 200);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_host', InternetProtocolSetRegistryList, 'HTTP', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_port', InternetProtocolSetRegistryList, 'HTTP');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_login', InternetProtocolSetRegistryList, 'HTTP', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_password', InternetProtocolSetRegistryList, 'HTTP', 195);
        }
        else if (p_index == 4)
        {
          $("#rbIntProtSet_HTTP_Security_SSLv2").jqxRadioButton(
          {
            groupName: 'internet_protocol_HTTP_Version_Group'
          });
          $("#rbIntProtSet_HTTP_Security_SSLv2_3").jqxRadioButton(
          {
            groupName: 'internet_protocol_HTTP_Version_Group'
          });
          $("#rbIntProtSet_HTTP_Security_SSLv3").jqxRadioButton(
          {
            groupName: 'internet_protocol_HTTP_Version_Group'
          });
          $("#rbIntProtSet_HTTP_Security_TLSv_1_1_2").jqxRadioButton(
          {
            groupName: 'internet_protocol_HTTP_Version_Group'
          });
          LoadRegistryItemToControlByName2('internet_protocol_HTTP_Version_Group', InternetProtocolSetRegistryList, 'HTTP', 195);

        }

      }

      function InitHTTPBar()
      {
        if (InternetProtSettingsTabsHTML_HTTP == '') return;
        $("#internet_settings_navigationbar_div").html(InternetProtSettingsTabsHTML_HTTP);
        $("#jqx_internet_settings_navigationbar").jqxNavigationBar(
        {
          width: '100%',
          height: 1000,
          toggleMode: "dblclick",
          expandMode: "toggle",
          initContent: OnInitNavBarContent
        });

        $("div.first").replaceWith('<div class="inner first"><br/>' + ProtocolName + ' Settings<br/></div>');

        GInternetProtSettingsBars = $("#jqx_internet_settings_navigationbar");
      }
      if (InternetProtSettingsTabsHTML_HTTP == '')
      {
        var client = new XMLHttpRequest();
        client.open('GET', '/m_InternetSettingsNavigationBar_HTTP.html');
        client.onreadystatechange = function()
        {
          if (client.readyState == XMLHttpRequest.DONE)
          {
             InternetProtSettingsTabsHTML_HTTP = client.responseText;
             InitHTTPBar();
          }
        }
        client.send();
      }
      else
        InitHTTPBar();

    }
    else if (GetBaseProtocolName(ProtocolName) == 'Sharepoint')
    {

      function OnInitNavBarContent(p_index)
      {

        if (p_index == 0)
        {
          $('#InternetSettingsOK_btn').jqxButton('disabled', false);
          LoadRegistryItemToControlByName2('inptIntProtSet_Sharepoint_domain', InternetProtocolSetRegistryList, 'Sharepoint', 225);
          LoadRegistryItemToControlByName2('inptInternetFolder', InternetProtocolSetRegistryList, 'Sharepoint', 195);
          LoadRegistryItemToControlByName2('inptIntProtSet_Sharepoint_account_id', InternetProtocolSetRegistryList, 'Sharepoint', 195);
          LoadRegistryItemToControlByName2('cbIntProtSet_allow_ipv6', InternetProtocolSetRegistryList, 'Sharepoint');

          var Obj = GetJSONObject('parseftpurl', [RawPathURL]);
          if (Obj != undefined)
          {
            $('#inptIntProtSet_Sharepoint_domain').jqxInput('val', Obj.server);
            $('#inptInternetFolder').jqxInput('val', Obj.folder);
            $('#inptIntProtSet_Sharepoint_account_id').jqxInput('val', Obj.user);
          }
        }
        else if (p_index == 1)
        {
          LoadRegistryItemToControlByName2('cbIntProtSet_adv_replace_characters', InternetProtocolSetRegistryList, '*');
        }
        else if (p_index == 2)
        {
          LoadRegistryItemToControlByName2('comboIntProtSet_proxy_type', InternetProtocolSetRegistryList, 'Sharepoint', 200);
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_host', InternetProtocolSetRegistryList, 'Sharepoint');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_port', InternetProtocolSetRegistryList, 'Sharepoint');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_login', InternetProtocolSetRegistryList, 'Sharepoint');
          LoadRegistryItemToControlByName2('inptIntProtSet_proxy_password', InternetProtocolSetRegistryList, 'Sharepoint');
        }

      }

      function InitSharepointBar()
      {
        if (InternetProtSettingsTabsHTML_Sharepoint == '') return;
        $("#internet_settings_navigationbar_div").html(InternetProtSettingsTabsHTML_Sharepoint);
        $("#jqx_internet_settings_navigationbar").jqxNavigationBar(
        {
          width: '100%',
          height: 1000,
          toggleMode: "dblclick",
          expandMode: "toggle",
          initContent: OnInitNavBarContent
        });

        $("div.first").replaceWith('<div class="inner first"><br/>' + ProtocolName + ' Settings<br/></div>');
        GInternetProtSettingsBars = $("#jqx_internet_settings_navigationbar");
      }
      if (InternetProtSettingsTabsHTML_Sharepoint == '')
      {
        var client = new XMLHttpRequest();
        client.open('GET', '/m_InternetSettingsNavigationBar_Sharepoint.html');
        client.onreadystatechange = function()
        {
          if (client.readyState == XMLHttpRequest.DONE)
          {
             InternetProtSettingsTabsHTML_Sharepoint = client.responseText;
             InitSharepointBar();
          }
        }
        client.send();
      }
      else
        InitSharepointBar();

    }
    else if (GetBaseProtocolName(ProtocolName) == '???')
    {
      /*
              function InitAzureBar()
              {
                   $("#internet_settings_navigationbar_div").html( InternetProtSettingsTabsHTML_Azure );
                   $("#jqx_internet_settings_navigationbar").jqxNavigationBar({ width: '100%', height: 1000, toggleMode: "dblclick",
                     expandMode: "toggle", initContent: OnInitNavBarContent });
                   GInternetProtSettingsBars = $("#jqx_internet_settings_navigationbar");
              }
              if(InternetProtSettingsTabsHTML_Azure == '')
                {
                  var client = new XMLHttpRequest();
                  client.open( 'GET', '/m_InternetSettingsNavigationBar_Azure.html' );
                  client.onreadystatechange = function()
                  {
                     if (client.readyState == XMLHttpRequest.DONE)
                     {
                        InternetProtSettingsTabsHTML_Azure = client.responseText;
                        InitAzureBar();
                     }
                  }
                   client.send();
                }
                else
                  InitAzureBar();
                */
    }

  }
  catch (err)
  {
    alert(err.message + ' function:  OnProtocolComboItem');
  }
}

var GInternetSettingsForm = null;

function m_InitProtocolSettingsForm(ProfileName, InternetProtocolSetRegistryList, LeftOrRight, ProtocolName, CurrentLeftRightEdit, RawPathURL)
{

  if (GInternetSettingsForm != null) // to avoid glitches when posting data
    GInternetSettingsForm.jqxWindow('destroy');
  CheckError(CurrentLeftRightEdit != undefined, "param CurrentLeftRightEdit is undefined");

  //GCurrentInternetProtocolSetRegistryList = InternetProtocolSetRegistryList;
  $("#ProtocolSettingsForm_div").html(ProtocolSettingsFormHTML);

  $('#jqxInternetSettingsForm').jqxWindow(
  {
    maxWidth: '100%',
    width: '100%',
    maxHeight: '100%',
    height: '100%',
    autoOpen: false,
    isModal: true,
    theme: 'energyblue',
    animationType: 'slide'
  });
  GInternetSettingsForm = $('#jqxInternetSettingsForm');

  $('#InternetSettingsCancel_btn').jqxButton(
  {
    width: 100,
    height: 30
  });

  $('#InternetSettingsCancel_btn').click(function()
  {

    $('#jqxInternetSettingsForm').jqxWindow('close');
    $('#jqxInternetSettingsForm').jqxWindow('destroy');
  });

  $('#InternetSettingsOK_btn').jqxButton(
  {
    width: 100,
    height: 30,
    disabled: true
  });

  $('#InternetSettingsOK_btn').click(function()
  {
    var aProtocolName = $("#jqxProtocolCombo").jqxDropDownList('val');

    CheckError(CurrentLeftRightEdit != undefined, "param CurrentLeftRightEdit is undefined");
    if (LeftOrRight == "Left")
    {
      //in synapp_profile_editor_form
      var Obj = StoragePathFromControlsToJSONObject(aProtocolName);
      if (Obj != undefined)
      {
        GLeftStoredPath = Obj.StoragePath;
        GLeftStoredPathDisplay = Obj.StorageDisplayPath;
        CurrentLeftRightEdit.jqxInput('val', Obj.StorageDisplayPath);
        GLeftProtocolName = aProtocolName;
      }
    }
    else if (LeftOrRight == "Right")
    {
      //in synapp_profile_editor_form
      var Obj = StoragePathFromControlsToJSONObject(aProtocolName);
      if (Obj != undefined)
      {
        GRightStoredPath = Obj.StoragePath;
        GRightStoredPathDisplay = Obj.StorageDisplayPath;
        CurrentLeftRightEdit.jqxInput('val', Obj.StorageDisplayPath);
        GRightProtocolName = aProtocolName;
      }
    }

    ControlValuesToRegistryList(InternetProtocolSetRegistryList, GetBaseProtocolName(aProtocolName));
    InternetProtocolSetRegistryList[indexOfListChanged].ListChanged = true;
    $('#jqxInternetSettingsForm').jqxWindow('close');
    $('#jqxInternetSettingsForm').jqxWindow('destroy');
  });

  var ProtocolComboSource = ['FTP', 'SSH', 'WebDAV', 'Amazon S3', 'HTTP', 'Azure', 'Glacier', 'Box', 'Google Drive', 'Google Cloud Storage',
    'DropBoxV2', 'Rackspace', 'OneDrvNew', 'OneDrive for Business', 'Sharepoint', 'Graph', 'SugarSync', 'MediaFire', 'B2',
    'Hubic', 'PCloud' ];

  // Create a jqxDropDownList
  $("#jqxProtocolCombo").jqxDropDownList(
  {
    source: ProtocolComboSource,
    selectedIndex: 0,
    width: 150,
    height: 30,
    itemHeight: 50
  });

  $("#jqxProtocolCombo").find('input').attr('readonly', 'readonly');

  $('#jqxProtocolCombo').on('change', function(event)
  {
    var args = event.args;
    if (args != undefined)
    {
      var item = event.args.item;

      if (item != null)
      {
        $('#InternetSettingsOK_btn').jqxButton('disabled', true);
        m_OnProtocolComboItem(ProfileName, InternetProtocolSetRegistryList, item.label, RawPathURL);
      }

    }
  });
  $("#jqxProtocolCombo").jqxDropDownList('val', ProtocolName);

  // assign jqxNavigationBar
  GInternetProtSettingsBars = null;

  $('#jqxInternetSettingsForm').jqxWindow('open');

  if (GetBaseProtocolName($("#jqxProtocolCombo").jqxDropDownList('val')) == ProtocolName)
    m_OnProtocolComboItem(ProfileName, InternetProtocolSetRegistryList, ProtocolName, RawPathURL);
  else
    $("#jqxProtocolCombo").jqxDropDownList('val', ProtocolName); // to cause onSelect event  //

  //m_OnProtocolComboItem( GSelectedProfileName, GCurrentInternetProtocolSetRegistryList, ProtocolName );
  /*var LCurrentProtoVal = $("#jqxProtocolCombo").jqxDropDownList('val');

         if (LCurrentProtoVal == GProtocolName)
            m_OnProtocolComboItem( GSelectedProfileName, GCurrentInternetProtocolSetRegistryList, GProtocolName );
         else
            $("#jqxProtocolCombo").jqxDropDownList( 'val', GProtocolName ); // to cause onSelect event  //
          */

}
